<!-- 退回操作 -->
<script lang="ts" setup name="RollbackDialog">
import type { FormInstance, FormRules } from 'element-plus'
import { ElMessage, ElMessageBox } from 'element-plus'
import { reactive, ref } from 'vue'
import { rollbackTask } from '@/api/business/task'

// 对外暴露的方法： 退回成功
const emit = defineEmits(['onSuccess'])
// 弹窗显示状态
const dialogVisible = ref(false)
// 默认表单
const defaultFormData = {
  id: '', //
  comments: '', // 备注
}
// 表单数据对象
const formData = reactive({ ...defaultFormData })

// 保存按钮加载状态
const btnLoading = ref(false)

// ---------------表单提交--------------------------------
// 表单对象
const dataFormRef = ref<FormInstance>()
// 校验规则
const rules: FormRules = reactive({
  comments: [{ required: true, message: '退回原因必填', trigger: ['blur', 'change'] }],
})
/**
 * 初始化审批弹窗
 * @param type 审批类型
 * @param taskId 任务id
 */
function initDialog(id: string) {
  formData.id = id
  formData.comments = ''
  dialogVisible.value = true
}
// 提交表单
function submitForm() {
  if (dataFormRef.value) {
    dataFormRef.value?.validate((valid: boolean) => {
      if (valid) {
        ElMessageBox.confirm(
          '确认退回分发吗？',
          '提示',
          { confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning' },
        ).then(() => {
          btnLoading.value = true
          rollbackTask(formData).then((res) => {
            ElMessage.success('操作成功')
            btnLoading.value = false
            dialogVisible.value = false
            emit('onSuccess')
          }).catch((_) => {
            btnLoading.value = false
          })
        })
      }
    })
  }
}
// 关闭弹窗
function handleClose() {
  dialogVisible.value = false
}

// ----------------------- 以下是暴露的方法内容 ----------------------------
defineExpose({ initDialog })
</script>

<template>
  <el-dialog
    v-model="dialogVisible"
    title="退回"
    width="600"
    :before-close="handleClose"
  >
    <el-form
      ref="dataFormRef"
      label-position="top"
      label-width="80px"
      :model="formData"
      :rules="rules"
    >
      <el-row :gutter="24">
        <el-col :span="24">
          <el-form-item label="请输入退回原因" props="comments">
            <el-input
              v-model="formData.comments"
              :rows="4"
              show-word-limit
              type="textarea"
            />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <template #footer>
      <el-button type="primary" :loading="btnLoading" @click="submitForm">
        提交
      </el-button>
      <el-button type="info" @click="handleClose">
        取消
      </el-button>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
// 样式
</style>
